#pragma semicolon 1

#include <ws_store>
#include <sourcemod>
#include <sdktools>

#define LASER_MODEL "sprites/laserbeam.vmt"

public Plugin:myinfo = 
{
	name	= "STORE (Lasers)",
	author	= "wS (World-Source.Ru)",
	version = "1.2"
};

new g_CategoryID, g_ItemID;
new g_Price, g_Limit, g_Count[MAXPLAYERS + 1];
new String:g_sWIDTH[5], String:g_sRGB[15], String:g_sA[5];
new bool:g_bFire, bool:g_bDissolve;

public OnPluginStart()
{
	CreateTimer(1.0, START);
}

public OnMapStart()
{
	PrecacheModel(LASER_MODEL);
}

public OnPluginEnd()
{
	if (g_CategoryID > 0 && !STORE_DeleteCategoryByID(g_CategoryID, true) && g_ItemID > 0)
		STORE_RemoveItemFromCategory(g_CategoryID, g_ItemID);
}

public STORE_Loaded()
{
	g_CategoryID = 0; g_ItemID = 0;
	decl String:PluginName[150]; PluginName[0] = '\0'; GetPluginFilename(GetMyHandle(), PluginName, 150);
	ServerCommand("sm plugins reload \"%s\"", PluginName);
}

public Action:START(Handle:timer)
{
	/////
	new Handle:kv = CreateKeyValues("store_lasers");

	if (!FileToKeyValues(kv, "cfg/store/modules/store_lasers.txt"))
		SetFailState("Error in cfg/store/modules/store_lasers.txt");

	decl String:CategoryName[STORE_CATEGORY_LENGTH];
	KvGetString(kv, "CategoryName", CategoryName, STORE_CATEGORY_LENGTH);
	if (TrimString(CategoryName) < 1)
		SetFailState("Категория не указана");

	new bool:bCategoryExist = (g_CategoryID = STORE_GetCategoryID(CategoryName)) > 0;
	decl String:Text[STORE_ITEMTEXT_LENGTH], String:str_flag[10];

	if (!bCategoryExist)
	{
		KvGetString(kv, "CategoryText", Text, STORE_ITEMTEXT_LENGTH);
		KvGetString(kv, "CategoryFlag", str_flag, 10);

		if ((g_CategoryID = STORE_CreateCategory(CategoryName, Text, str_flag)) < 1)
			SetFailState("Не удалось создать категорию '%s'", CategoryName);
	}

	g_Price = KvGetNum(kv, "price");
	KvGetString(kv, "ItemText", Text, STORE_ITEMTEXT_LENGTH);
	if (TrimString(Text) > 0)
	{
		KvGetString(kv, "ItemFlag", str_flag, 10);
		if ((g_ItemID = STORE_AddItemToCategory(g_CategoryID, Text, g_Price, true, MyCallBack, str_flag)) < 1)
		{
			if (!bCategoryExist)
			{
				STORE_DeleteCategoryByID(g_CategoryID, true);
				g_CategoryID = 0;
			}
			SetFailState("Не удалось добавить функцию '%s'", Text);
		}
	}
	else if (bCategoryExist)
		SetFailState("Укажите уникальное название категории или используйте ItemText");

	g_bFire			= KvGetNum(kv, "fire") == 1;
	g_bDissolve		= KvGetNum(kv, "dissolve") == 1;

	if ((g_Limit	= KvGetNum(kv, "round_limit")) < 1) g_Limit = 1;
	else if (g_Limit > 10) g_Limit = 10;

	KvGetString(kv, "width", g_sWIDTH, sizeof(g_sWIDTH));
	KvGetString(kv, "rgb", g_sRGB, sizeof(g_sRGB));
	KvGetString(kv, "a", g_sA, sizeof(g_sA));

	CloseHandle(kv);
	/////

	HookEvent("round_start", round_start, EventHookMode_PostNoCopy);
	return Plugin_Stop;
}


///


public MyCallBack(client, const String:steamid[], CategoryID, ItemID, ItemPrice)
{
	if (ItemID == g_ItemID)
		wS_OnClientSelect(client, LastMenuItem:MI_InCategory);
}

public STORE_OnClientSelectEmptyCategory(client, const String:steamid[], CategoryID)
{
	if (CategoryID == g_CategoryID)
		wS_OnClientSelect(client, LastMenuItem:MI_Main);
}

stock wS_OnClientSelect(client, LastMenuItem:MI)
{
	if (!IsPlayerAlive(client))
	{
		PrintCenterText(client, "Вы мертвы");
		STORE_ShowMenu(client, MI);
		return;
	}

	if (g_Limit > 0 && g_Count[client] >= g_Limit)
	{
		PrintCenterText(client, "Будет доступно в следующем раунде");
		STORE_ShowMenu(client, MI);
		return;
	}

	decl Float:start_pos[3];
	new result = wS_GetAimInfo(client, true, true, start_pos);
	if (result == -5)
	{
		PrintToChat(client, "Ошибка");
		return;
	}
	if (0 < result <= MaxClients)
	{
		PrintCenterText(client, "Уберите прицел с игрока");
		STORE_ShowMenu(client, MI);
		return;
	}

	if (g_Price > 0)
	{
		new credits = STORE_GetCredits(client);

		if (credits < g_Price)
		{
			PrintCenterText(client, "Вам не хватает %d кр", (g_Price - credits));
			STORE_ShowMenu(client, MI);
			return;
		}

		if (!STORE_SetCredits(client, (credits - g_Price)))
		{
			LogError("Не удалось установить кредиты игроку '%N'", client);
			return;
		}
	}

	g_Count[client]++;
	wS_CreateLaser(client, start_pos);

	STORE_ShowMenu(client, MI);
}


///


public round_start(Handle:event, const String:name[], bool:silent)
{
	for (new i = 1; i <= MaxClients; i++) g_Count[i] = 0;
}

public OnClientConnected(client)
{
	g_Count[client] = 0;
}


///


stock wS_CreateLaser(client, const Float:start_pos[3])
{
	new ent = CreateEntityByName("env_beam");
	if (ent < 1)
	{
		LogError("Can't create 'env_beam'");
		return;
	}

	///
	decl Float:end_pos[3];
	TR_GetPlaneNormal(INVALID_HANDLE, end_pos);
	GetVectorAngles(end_pos, end_pos);
	TR_TraceRayFilter(start_pos, end_pos,	MASK_SOLID, RayType_Infinite, LaserFilter);
	if (!TR_DidHit())
	{
		AcceptEntityInput(ent, "Kill");
		LogError("TR_DidHit false");
		return;
	}
	TR_GetEndPosition(end_pos);
	///

	DispatchKeyValueVector(ent, "origin",	start_pos);
	DispatchKeyValue(ent, "texture",		LASER_MODEL);
	SetEntityModel(ent, LASER_MODEL);
	DispatchKeyValue(ent, "life",			"0");
	DispatchKeyValue(ent, "spawnflags",		"48");
	DispatchKeyValue(ent, "rendercolor",	g_sRGB);
	DispatchKeyValue(ent, "renderamt",		g_sA);
	DispatchKeyValue(ent, "BoltWidth",		g_sWIDTH);
	DispatchKeyValue(ent, "TouchType",		"1");
	SetEntPropVector(ent, Prop_Data, "m_vecEndPos", end_pos);
	DispatchSpawn(ent);
	AcceptEntityInput(ent, "TurnOn");

	HookSingleEntityOutput(ent, "OnTouchedByEntity", Event_LaserTouched, true);
}

public bool:LaserFilter(ent, mask)
{
	return ent < 1 || ent > MaxClients;
}

public Event_LaserTouched(const String:output[], ent, activator, Float:delay)
{
	AcceptEntityInput(ent, "Kill");

	if (!(0 < activator <= MaxClients))
		return;

	ForcePlayerSuicide(activator);

	new ragdoll = GetEntPropEnt(activator, Prop_Send, "m_hRagdoll");
	if (ragdoll > 0 && IsValidEntity(ragdoll))
	{
		if (g_bFire)
		{
			IgniteEntity(ragdoll, 3.0);
			SetVariantString("OnUser2 !self:kill::3.0:1");
			AcceptEntityInput(ragdoll, "AddOutput");
			AcceptEntityInput(ragdoll, "FireUser2");
		}
		if (g_bDissolve)
		{
			new entity = CreateEntityByName("env_entity_dissolver");
			if (entity > 0)
			{
				decl String:name[25];
				Format(name, 25, "dsslvr%d", entity);
				DispatchKeyValue(ragdoll,	"targetname",	name);

				DispatchKeyValue(entity,	"target",		name);
				DispatchKeyValue(entity,	"magnitude",	"1");
				DispatchKeyValue(entity,	"dissolvetype",	"0");
				AcceptEntityInput(entity,	"Dissolve");
				AcceptEntityInput(entity,	"Kill");
			}
			else
				LogError("Can't create 'env_entity_dissolver'");
		}
	}
}


///


stock wS_GetAimInfo(client, bool:get_index = true, bool:get_origin = false, Float:end_origin[3] = {0.0, 0.0, 0.0})
{
	decl Float:angles[3];
	if (!GetClientEyeAngles(client, angles))
		return -5;

	decl Float:origin[3]; GetClientEyePosition(client, origin);
	TR_TraceRayFilter(origin, angles, MASK_SOLID, RayType_Infinite, wS_GetAimInfo_Filter, client);

	if (!TR_DidHit())
		return -5;

	if (get_origin)
	{
		TR_GetEndPosition(end_origin);
		if (!get_index)
			return 0;
	}

	if (get_index)
		return TR_GetEntityIndex();

	return -5;
}

public bool:wS_GetAimInfo_Filter(TraceEnt, mask, any:entity)
{
	return TraceEnt != entity;
}